#ifndef DUMPDEVICE_H
#define DUMPDEVICE_H

/* $Id: dumpdevice.h,v 1.15 2005/11/09 19:48:31 tachino Exp $ */

#include <glib.h>
#include <stdbool.h>
#include "dumpheader.h"
#include "dumpfile.h"
#include "arch/arch_dumpdevice.h"

typedef struct _DumpDevice DumpDevice;

struct mem_segment {
	unsigned int	blk;
	unsigned int	len;
};

struct _DumpDevice {

	/* Host data */
	glong			 page_offset;
	struct disk_dump_header	*header;
	struct disk_dump_sub_header	*sub_header;
	int			 sub_header_len;


	char			*bitmap;
	int			 bitmap_len;
	char			*dumpable_bitmap;

	int			byte, bit;

	struct mem_segment	*segments;
	int			 num_segments;

	/* Coredump data: */
	int			 fd;
	char			*name;
	size_t			 device_page_start;

	DumpFile		*dump_file;
};

static inline int device_seek(DumpDevice *device, off_t off) {
	if (lseek(device->fd, off, SEEK_SET) == off)
		return 0;
	else
		return -1;
}

#endif
